{{
##################################
# jvmVpDemo - Demo for jvmVpCore #
##################################

This is the demo section only. See jvmVpCore.spin for detailed design.

}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  vp : "jvmVpCore"
  jd : "jvmVpData"
  def: "jvmDefines"
  sio: "jvmSerial"

VAR
  long vpRambank
  
PUB main

  sio.start(31,30,0,28800)

  vpRambank := jd.getVpRamAddr
  vp.start(vpRambank)
  
  sio.rx ' uncomment to pause before demo

  sio.tx($d)
  sio.str(string("vpRamBank address: "))
  sio.hex(vpRambank,4)

  doPWM(def#nmPeriph5Bank, 2, 6, 3)
  'doTimer(def#nmPeriph0Bank)

  repeat
  
PUB doPWM(bank, pin, hi, lo)
  vp.startPWM(vpRambank, bank, 0, pin, hi, lo)


PUB doTimer(bank)
  vp.startVP(vpRambank, bank, vp#VP_TIMER)
  printTimer(bank)
  pause(1000)
  printTimer(bank)
  dumpBytes(vpRambank,$50)

  vp.stopVP(bank)
  printTimer(bank)
  dumpBytes(vpRambank,$50)

  jd.writeRegister(bank + def#nmTimer1, 0)
  jd.writeRegister(bank + def#nmTimer2, 0)
  jd.writeRegister(bank + def#nmTimer3, 0)
  jd.writeRegister(bank + def#nmTimer4, 0)
  vp.startVP(vpRambank, bank, vp#VP_TIMER)

  repeat
    pause(500)
    printTimer(bank)
    'dumpBytes(jd.getVpRamAddr,$10)

PRI printTimer(bank)
  sio.tx($d)
  sio.hex(bank,4)

  jd.writeRegister(bank + def#nmLatchTimer1,jd.readRegister(bank + def#nmTimer1))
  jd.writeRegister(bank + def#nmLatchTimer2,jd.readRegister(bank + def#nmTimer2))
  jd.writeRegister(bank + def#nmLatchTimer3,jd.readRegister(bank + def#nmTimer3))
  jd.writeRegister(bank + def#nmLatchTimer4,jd.readRegister(bank + def#nmTimer4))

  sio.str(string(" raw: "))
  sio.hex(def#nmTimer1,4)
  sio.tx(" ")

  sio.hex(jd.readRegister(bank + def#nmTimer4),2)
  sio.hex(jd.readRegister(bank + def#nmTimer3),2)
  sio.hex(jd.readRegister(bank + def#nmTimer2),2)
  sio.hex(jd.readRegister(bank + def#nmTimer1),2)

  sio.str(string(" latched: "))
  sio.hex(def#nmLatchTimer1,4)
  sio.tx(" ")

  sio.hex(jd.readRegister(bank + def#nmLatchTimer4),2)
  sio.hex(jd.readRegister(bank + def#nmLatchTimer3),2)
  sio.hex(jd.readRegister(bank + def#nmLatchTimer2),2)
  sio.hex(jd.readRegister(bank + def#nmLatchTimer1),2)
  
PRI dumpBytes(addr,len) | ndx, bytes[17], bi, sz
{{
/**
 * dump bytes in 8 column table
 * @param addr is base address for dump
 * @param len is number of bytes to dump
 */
__ void dumpBytes(addr,len);
}}
  ndx := 0
  sz  := 16
  'str(string("Dump"))
  repeat while(ndx < len)
    if ndx <> 0 and (ndx // sz) <> 0
      sio.tx(".")
      bytes[bi++ // sz] := byte[addr+ndx-1] 
    if ndx == 0 or (ndx // sz) == 0
      if ndx <> 0
        bytes[bi] := byte[addr+ndx-1]
        sio.tx(" ")
        repeat bi from 0 to sz-1
          if (bytes[bi] => $20)
            sio.tx(bytes[bi])
          else
            sio.tx(".")
      sio.tx($d)
      sio.hex(addr+ndx,4)
      sio.tx(":")
      sio.tx(" ")
      bi  := 0
    sio.hex(byte[addr+ndx],2)
    ndx++
    
  if ndx <> 0
     sio.tx(" ")
     bytes[bi] := byte[addr+ndx-1]
     repeat bi from 0 to sz-1
       if (bytes[bi] => $20)
         sio.tx(bytes[bi])
       else
         sio.tx(".")

PRI pause(ms)
  if ms < 10
    result := ((clkfreq / 1000000) * 9050) / 10
  elseif ms < 100    
    result := ((clkfreq / 1000000) * 9950) / 10
  elseif ms < 1000 
    result := ((clkfreq / 1000000) * 10090) / 10
  else
    result := (clkfreq / 1000)
  result *= ms
  waitcnt(cnt+result)